/*****< btpmerr.h >************************************************************/
/*      Copyright 2010 - 2014 Stonestreet One.                                */
/*      All Rights Reserved.                                                  */
/*                                                                            */
/*  BTPMERR - Bluetopia Platform Manager Error constants and error message    */
/*            conversion functions.                                           */
/*                                                                            */
/*  Author:  Damon Lange                                                      */
/*                                                                            */
/*** MODIFICATION HISTORY *****************************************************/
/*                                                                            */
/*   mm/dd/yy  F. Lastname    Description of Modification                     */
/*   --------  -----------    ------------------------------------------------*/
/*   06/19/10  D. Lange       Initial creation.                               */
/******************************************************************************/
#ifndef __BTPMERRH__
#define __BTPMERRH__

#include "BTAPITyp.h"            /* Bluetooth API Type Definitions.           */

#define BTPM_ERROR_CODE_INVALID_PARAMETER                         (-10001)
#define BTPM_ERROR_CODE_INVALID_CALLBACK_SPECIFIED                (-10002)
#define BTPM_ERROR_CODE_UNABLE_TO_CREATE_MAILBOX                  (-10003)
#define BTPM_ERROR_CODE_UNABLE_TO_CREATE_MUTEX                    (-10004)
#define BTPM_ERROR_CODE_UNABLE_TO_CREATE_EVENT                    (-10005)
#define BTPM_ERROR_CODE_UNABLE_TO_CREATE_THREAD                   (-10006)
#define BTPM_ERROR_CODE_UNABLE_TO_ALLOCATE_MEMORY                 (-10007)
#define BTPM_ERROR_CODE_INSUFFICIENT_BUFFER_SIZE                  (-10008)
#define BTPM_ERROR_CODE_UNABLE_TO_ADD_ENTRY                       (-10009)
#define BTPM_ERROR_CODE_UNABLE_TO_REGISTER_HANDLER                (-10010)
#define BTPM_ERROR_CODE_UNABLE_TO_LOCK_CONTEXT                    (-10011)
#define BTPM_ERROR_CODE_UNABLE_TO_POST_MAILBOX                    (-10012)
#define BTPM_ERROR_CODE_UNABLE_TO_ALLOCATE_TIMER                  (-10013)
#define BTPM_ERROR_CODE_ALREADY_INITIALIZED                       (-10014)
#define BTPM_ERROR_CODE_PLATFORM_MANAGER_NOT_INITIALIZED          (-10015)
#define BTPM_ERROR_CODE_TIMER_SYSTEM_NOT_INITIALIZED              (-10016)
#define BTPM_ERROR_CODE_IPC_MODULE_NOT_INITIALIZED                (-10017)
#define BTPM_ERROR_CODE_IPC_UNABLE_TO_OPEN_DEVICE                 (-10018)
#define BTPM_ERROR_CODE_IPC_UNABLE_TO_OPEN_PIPE                   (-10019)
#define BTPM_ERROR_CODE_IPC_UNABLE_TO_OPEN_SOCKET                 (-10020)
#define BTPM_ERROR_CODE_IPC_SERVER_ALREADY_RUNNING                (-10021)
#define BTPM_ERROR_CODE_IPC_PIPE_ERROR                            (-10022)
#define BTPM_ERROR_CODE_IPC_SOCKET_ERROR                          (-10023)
#define BTPM_ERROR_CODE_IPC_UNABLE_TO_SEND_DATA                   (-10024)
#define BTPM_ERROR_CODE_IPC_UNABLE_TO_RECEIVE_DATA                (-10025)
#define BTPM_ERROR_CODE_IPC_SERVER_CLOSED                         (-10026)
#define BTPM_ERROR_CODE_MESSAGE_SYSTEM_NOT_INITIALIZED            (-10027)
#define BTPM_ERROR_CODE_INVALID_MESSAGE_GROUP                     (-10028)
#define BTPM_ERROR_CODE_INVALID_MESSAGE_FUNCTION                  (-10029)
#define BTPM_ERROR_CODE_INVALID_MESSAGE_ID                        (-10030)
#define BTPM_ERROR_CODE_RESPONSE_MESSAGE_INVALID                  (-10031)
#define BTPM_ERROR_CODE_RESPONSE_MESSAGE_TIMEOUT                  (-10032)
#define BTPM_ERROR_CODE_MESSAGE_PROCESSING_ERROR                  (-10033)
#define BTPM_ERROR_CODE_LOCAL_DEVICE_NOT_INITIALIZED              (-10034)
#define BTPM_ERROR_CODE_LOCAL_DEVICE_POWERED_DOWN                 (-10035)
#define BTPM_ERROR_CODE_LOCAL_DEVICE_ALREADY_POWERED_DOWN         (-10036)
#define BTPM_ERROR_CODE_LOCAL_DEVICE_ALREADY_POWERED_UP           (-10037)
#define BTPM_ERROR_CODE_LOCAL_DEVICE_POWERING_DOWN                (-10038)
#define BTPM_ERROR_CODE_LOCAL_DEVICE_POWERING_UP                  (-10039)
#define BTPM_ERROR_CODE_BLUETOOTH_DEBUG_ALREADY_ENABLED           (-10040)
#define BTPM_ERROR_CODE_UNKNOWN_BLUETOOTH_DEVICE                  (-10041)
#define BTPM_ERROR_CODE_BLUETOOTH_DEVICE_ALREADY_EXISTS           (-10042)
#define BTPM_ERROR_CODE_BLUETOOTH_DEVICE_ALREADY_PAIRED           (-10043)
#define BTPM_ERROR_CODE_DEVICE_CONNECTION_IN_PROGRESS             (-10044)
#define BTPM_ERROR_CODE_DEVICE_IS_CURRENTLY_CONNECTED             (-10045)
#define BTPM_ERROR_CODE_DEVICE_IS_NOT_CURRENTLY_CONNECTED         (-10046)
#define BTPM_ERROR_CODE_DEVICE_DISCOVERY_IN_PROGRESS              (-10047)
#define BTPM_ERROR_CODE_DEVICE_PAIRING_IN_PROGRESS                (-10048)
#define BTPM_ERROR_CODE_DEVICE_NOT_CURRENTLY_IN_PAIRING_PROCESS   (-10049)
#define BTPM_ERROR_CODE_PROPERTY_UPDATE_IN_PROGRESS               (-10050)
#define BTPM_ERROR_CODE_SERVICE_DISCOVERY_IN_PROGRESS             (-10051)
#define BTPM_ERROR_CODE_AUTHENTICATION_HANDLER_ALREADY_REGISTERED (-10052)
#define BTPM_ERROR_CODE_AUTHENTICATION_HANDLER_NOT_REGISTERED     (-10053)
#define BTPM_ERROR_CODE_INVALID_AUTHENTICATION_ACTION_SPECIFIED   (-10054)
#define BTPM_ERROR_CODE_DEVICE_SERVICES_NOT_KNOWN                 (-10055)
#define BTPM_ERROR_CODE_UNABLE_TO_PARSE_SERVICE_DATA              (-10056)
#define BTPM_ERROR_CODE_SERVICE_DATA_INVALID                      (-10057)
#define BTPM_ERROR_CODE_DEVICE_IN_NON_PAIRABLE_MODE               (-10058)
#define BTPM_ERROR_CODE_DEVICE_COMMUNICATION_ERROR                (-10059)
#define BTPM_ERROR_CODE_DEVICE_ALREADY_AUTHENTICATED              (-10060)
#define BTPM_ERROR_CODE_DEVICE_AUTHENTICATION_IN_PROGRESS         (-10061)
#define BTPM_ERROR_CODE_DEVICE_AUTHENTICATION_FAILED              (-10062)
#define BTPM_ERROR_CODE_DEVICE_ALREADY_ENCRYPTED                  (-10063)
#define BTPM_ERROR_CODE_DEVICE_ENCRYPTION_IN_PROGRESS             (-10064)
#define BTPM_ERROR_CODE_DEVICE_ENCRYPTION_FAILED                  (-10065)
#define BTPM_ERROR_CODE_DEVICE_CONNECTION_FAILED                  (-10066)
#define BTPM_ERROR_CODE_DEVICE_CONNECTION_RETRIES_EXCEEDED        (-10067)
#define BTPM_ERROR_CODE_DEVICE_EXIT_SNIFF_MODE_ERROR              (-10068)
#define BTPM_ERROR_CODE_DEVICE_SNIFF_MODE_NOT_ACTIVE              (-10069)
#define BTPM_ERROR_CODE_SERVICE_RECORD_ATTRIBUTE_DATA_INVALID     (-10070)
#define BTPM_ERROR_CODE_SERVICE_RECORD_ALREADY_REGISTERED         (-10071)
#define BTPM_ERROR_CODE_SERIAL_PORT_NOT_INITIALIZED               (-10072)
#define BTPM_ERROR_CODE_INVALID_CONNECTION_STATE                  (-10073)
#define BTPM_ERROR_CODE_INVALID_SERIAL_PORT                       (-10074)
#define BTPM_ERROR_CODE_UNABLE_TO_CONNECT_REMOTE_SERIAL_PORT      (-10075)
#define BTPM_ERROR_CODE_REMOTE_SERIAL_PORT_CONNECTION_REFUSED     (-10076)
#define BTPM_ERROR_CODE_SERIAL_PORT_CLOSE_IN_PROGRESS             (-10077)
#define BTPM_ERROR_CODE_SERIAL_PORT_READ_IN_PROGRESS              (-10078)
#define BTPM_ERROR_CODE_SERIAL_PORT_WRITE_IN_PROGRESS             (-10079)
#define BTPM_ERROR_CODE_SERIAL_PORT_WRITE_DATA_FLUSH_STARTED      (-10080)
#define BTPM_ERROR_CODE_SERIAL_PORT_WRITE_DATA_FLUSH_TIMEOUT      (-10081)
#define BTPM_ERROR_CODE_SERIAL_PORT_INVALID_BLOCKING_OPERATION    (-10082)
#define BTPM_ERROR_CODE_SERIAL_PORT_IS_STILL_CONNECTED            (-10083)
#define BTPM_ERROR_CODE_SERIAL_PORT_CONNECTION_RETRIES_EXCEEDED   (-10084)
#define BTPM_ERROR_CODE_SERIAL_PORT_INVALID_MFI_CONFIGURATION     (-10085)
#define BTPM_ERROR_CODE_SERIAL_PORT_AUTHENTICATION_COPROCESSOR    (-10086)
#define BTPM_ERROR_CODE_SERIAL_PORT_OPERATION_ERROR               (-10087)
#define BTPM_ERROR_CODE_SERIAL_PORT_INVALID_SESSION_ID            (-10088)
#define BTPM_ERROR_CODE_SERIAL_PORT_MFI_DISCOVERY_ERROR           (-10089)
#define BTPM_ERROR_CODE_SERIAL_PORT_MFI_NOT_SUPPORTED             (-10090)
#define BTPM_ERROR_CODE_SERIAL_PORT_IS_NOT_AVAILABLE              (-10091)
#define BTPM_ERROR_CODE_LOW_ENERGY_NOT_SUPPORTED                  (-10092)
#define BTPM_ERROR_CODE_LOW_ENERGY_NOT_CONNECTED                  (-10093)
#define BTPM_ERROR_CODE_NO_CONFIGURED_LOCAL_DEVICE_ID_INFORMATION (-10094)
#define BTPM_ERROR_CODE_INVALID_FEATURE_ACTION                    (-10095)
#define BTPM_ERROR_CODE_LOW_ENERGY_NOT_CURRENTLY_ENABLED          (-10096)
#define BTPM_ERROR_CODE_ANT_PLUS_NOT_SUPPORTED                    (-10097)
#define BTPM_ERROR_CODE_ANT_PLUS_NOT_CURRENTLY_ENABLED            (-10098)
#define BTPM_ERROR_CODE_INVALID_LOW_ENERGY_MASTER_SLAVE_ROLE      (-10099)

#define BTPM_ERROR_CODE_SCO_NOT_INITIALIZED                       (-10100)
#define BTPM_ERROR_CODE_INVALID_SCO_CONNECTION                    (-10101)
#define BTPM_ERROR_CODE_UNABLE_TO_CONNECT_REMOTE_SCO_CONNECTION   (-10102)
#define BTPM_ERROR_CODE_SCO_CONNECTION_CLOSE_IN_PROGRESS          (-10103)
#define BTPM_ERROR_CODE_INVALID_AUDIO_INITIALIZATION_DATA         (-10104)

#define BTPM_ERROR_CODE_AUDIO_NOT_INITIALIZED                     (-10200)
#define BTPM_ERROR_CODE_UNABLE_TO_CONNECT_REMOTE_AUDIO_STREAM     (-10201)
#define BTPM_ERROR_CODE_AUDIO_STREAM_CONNECTION_IN_PROGRESS       (-10202)
#define BTPM_ERROR_CODE_AUDIO_STREAM_ALREADY_CONNECTED            (-10203)
#define BTPM_ERROR_CODE_AUDIO_STREAM_NOT_CONNECTED                (-10204)
#define BTPM_ERROR_CODE_AUDIO_STREAM_EVENT_HANDLER_NOT_REGISTERED (-10205)
#define BTPM_ERROR_CODE_AUDIO_STREAM_STATE_CHANGE_IN_PROGRESS     (-10206)
#define BTPM_ERROR_CODE_AUDIO_STREAM_FORMAT_CHANGE_IN_PROGRESS    (-10207)
#define BTPM_ERROR_CODE_AUDIO_STREAM_FORMAT_IS_NOT_SUPPORTED      (-10208)
#define BTPM_ERROR_CODE_AUDIO_STREAM_STATE_IS_ALREADY_STARTED     (-10209)
#define BTPM_ERROR_CODE_AUDIO_STREAM_STATE_IS_ALREADY_SUSPENDED   (-10210)
#define BTPM_ERROR_CODE_AUDIO_STREAM_DATA_ALREADY_REGISTERED      (-10211)
#define BTPM_ERROR_CODE_AUDIO_STREAM_ACTION_NOT_PERMITTED         (-10212)
#define BTPM_ERROR_CODE_REMOTE_CONTROL_EVENT_ALREADY_REGISTERED   (-10213)
#define BTPM_ERROR_CODE_UNKNOWN_REMOTE_CONTROL_EVENT_TYPE         (-10214)
#define BTPM_ERROR_CODE_INVALID_REMOTE_CONTROL_EVENT_DATA         (-10215)
#define BTPM_ERROR_CODE_UNABLE_TO_SEND_REMOTE_CONTROL_COMMAND     (-10216)
#define BTPM_ERROR_CODE_UNABLE_TO_SEND_REMOTE_CONTROL_RESPONSE    (-10217)
#define BTPM_ERROR_CODE_REMOTE_CONTROL_RESPONSE_TIMEOUT_ERROR     (-10218)
#define BTPM_ERROR_CODE_REMOTE_CONTROL_RESPONSE_UNKNOWN_ERROR     (-10219)
#define BTPM_ERROR_CODE_AUDIO_STREAM_NOT_INITIALIZED              (-10220)
#define BTPM_ERROR_CODE_REMOTE_CONTROL_CONNECTION_IN_PROGRESS     (-10221)
#define BTPM_ERROR_CODE_REMOTE_CONTROL_ALREADY_CONNECTED          (-10222)
#define BTPM_ERROR_CODE_REMOTE_CONTROL_NOT_CONNECTED              (-10223)
#define BTPM_ERROR_CODE_UNABLE_TO_CONNECT_REMOTE_CONTROL          (-10224)
#define BTPM_ERROR_CODE_REMOTE_CONTROL_ROLE_IS_NOT_REGISTERED     (-10225)
#define BTPM_ERROR_CODE_TIMER_PLATFORM_ERROR                      (-10226)
#define BTPM_ERROR_CODE_OBSERVATION_SCAN_IN_PROGESS               (-10227)
#define BTPM_ERROR_CODE_INTERLEAVED_ADVERTISING_ACTIVE            (-10228)
#define BTPM_ERROR_CODE_ADVERTISING_NOT_CURRENTLY_ENABLED         (-10229)
#define BTPM_ERROR_CODE_INTERLEAVED_ADVERTISING_SUSPENDED         (-10230)

#define BTPM_ERROR_CODE_HID_NOT_INITIALIZED                       (-10300)
#define BTPM_ERROR_CODE_HID_DEVICE_ALREADY_CONNECTED              (-10301)
#define BTPM_ERROR_CODE_HID_DEVICE_CONNECTION_IN_PROGRESS         (-10302)
#define BTPM_ERROR_CODE_UNABLE_TO_CONNECT_REMOTE_HID_DEVICE       (-10303)
#define BTPM_ERROR_CODE_HID_EVENT_HANDLER_NOT_REGISTERED          (-10304)
#define BTPM_ERROR_CODE_HID_DATA_EVENTS_ALREADY_REGISTERED        (-10305)
#define BTPM_ERROR_CODE_HID_DATA_EVENT_HANDLER_NOT_REGISTERED     (-10306)
#define BTPM_ERROR_CODE_HID_UNABLE_TO_CLOSE_REMOTE_HID_DEVICE     (-10307)
#define BTPM_ERROR_CODE_NO_ASSOCIATED_HID_DEVICES_FOR_WAKEUP      (-10308)
#define BTPM_ERROR_CODE_MAXIMUM_ASSOCIATED_HID_DEVICES_REACHED    (-10309)
#define BTPM_ERROR_CODE_HID_DEVICE_NOT_ASSOCIATED                 (-10310)
#define BTPM_ERROR_CODE_HID_DEVICE_ALREADY_ASSOCIATED             (-10311)

#define BTPM_ERROR_CODE_HANDS_FREE_NOT_INITIALIZED                   (-10400)
#define BTPM_ERROR_CODE_INVALID_HANDS_FREE_INITIALIZATION_DATA       (-10401)
#define BTPM_ERROR_CODE_HANDS_FREE_ROLE_NOT_SUPPORTED                (-10402)
#define BTPM_ERROR_CODE_HANDS_FREE_INVALID_OPERATION                 (-10403)
#define BTPM_ERROR_CODE_HANDS_FREE_CONNECTION_IN_PROGRESS            (-10404)
#define BTPM_ERROR_CODE_HANDS_FREE_ALREADY_CONNECTED                 (-10405)
#define BTPM_ERROR_CODE_HANDS_FREE_NOT_CONNECTED                     (-10406)
#define BTPM_ERROR_CODE_HANDS_FREE_IS_STILL_CONNECTED                (-10407)
#define BTPM_ERROR_CODE_HANDS_FREE_UNABLE_TO_CONNECT_TO_DEVICE       (-10408)
#define BTPM_ERROR_CODE_HANDS_FREE_CONNECTION_RETRIES_EXCEEDED       (-10409)
#define BTPM_ERROR_CODE_HANDS_FREE_UNABLE_TO_DISCONNECT_DEVICE       (-10410)
#define BTPM_ERROR_CODE_HANDS_FREE_EVENT_HANDLER_ALREADY_REGISTERED  (-10411)
#define BTPM_ERROR_CODE_HANDS_FREE_EVENT_HANDLER_NOT_REGISTERED      (-10412)
#define BTPM_ERROR_CODE_HANDS_FREE_DATA_HANDLER_ALREADY_REGISTERED   (-10413)
#define BTPM_ERROR_CODE_HANDS_FREE_DATA_HANDLER_NOT_REGISTERED       (-10414)

#define BTPM_ERROR_CODE_PHONE_BOOK_ACCESS_NOT_INITIALIZED                   (-10500)
#define BTPM_ERROR_CODE_INVALID_PHONE_BOOK_ACCESS_INITIALIZATION_DATA       (-10501)
#define BTPM_ERROR_CODE_PHONE_BOOK_ACCESS_CLOSE_IN_PROGRESS                 (-10502)
#define BTPM_ERROR_CODE_PHONE_BOOK_ACCESS_ROLE_NOT_SUPPORTED                (-10503)
#define BTPM_ERROR_CODE_PHONE_BOOK_ACCESS_INVALID_OPERATION                 (-10504)
#define BTPM_ERROR_CODE_PHONE_BOOK_ACCESS_CONNECTION_IN_PROGRESS            (-10505)
#define BTPM_ERROR_CODE_PHONE_BOOK_ACCESS_ALREADY_CONNECTED                 (-10506)
#define BTPM_ERROR_CODE_PHONE_BOOK_ACCESS_NOT_CONNECTED                     (-10507)
#define BTPM_ERROR_CODE_PHONE_BOOK_ACCESS_IS_STILL_CONNECTED                (-10508)
#define BTPM_ERROR_CODE_PHONE_BOOK_ACCESS_UNABLE_TO_CONNECT_TO_DEVICE       (-10509)
#define BTPM_ERROR_CODE_PHONE_BOOK_ACCESS_CONNECTION_RETRIES_EXCEEDED       (-10510)
#define BTPM_ERROR_CODE_PHONE_BOOK_ACCESS_UNABLE_TO_DISCONNECT_DEVICE       (-10511)
#define BTPM_ERROR_CODE_PHONE_BOOK_ACCESS_EVENT_HANDLER_ALREADY_REGISTERED  (-10512)
#define BTPM_ERROR_CODE_PHONE_BOOK_ACCESS_EVENT_HANDLER_NOT_REGISTERED      (-10513)
#define BTPM_ERROR_CODE_PHONE_BOOK_ACCESS_DATA_HANDLER_ALREADY_REGISTERED   (-10514)
#define BTPM_ERROR_CODE_PHONE_BOOK_ACCESS_DATA_HANDLER_NOT_REGISTERED       (-10515)
#define BTPM_ERROR_CODE_PHONE_BOOK_ACCESS_INVALID_CLIENT                    (-10516)
#define BTPM_ERROR_CODE_PHONE_BOOK_ACCESS_INVALID_SERVER_ID                 (-10517)

#define BTPM_ERROR_CODE_PAN_NOT_INITIALIZED                       (-10600)
#define BTPM_ERROR_CODE_INVALID_PAN_INITIALIZATION_DATA           (-10601)
#define BTPM_ERROR_CODE_PAN_ROLE_NOT_SUPPORTED                    (-10602)
#define BTPM_ERROR_CODE_PAN_INVALID_OPERATION                     (-10603)
#define BTPM_ERROR_CODE_PAN_CONNECTION_IN_PROGRESS                (-10604)
#define BTPM_ERROR_CODE_PAN_DEVICE_ALREADY_CONNECTED              (-10605)
#define BTPM_ERROR_CODE_PAN_DEVICE_NOT_CONNECTED                  (-10606)
#define BTPM_ERROR_CODE_PAN_DEVICE_IS_STILL_CONNECTED             (-10607)
#define BTPM_ERROR_CODE_PAN_UNABLE_TO_CONNECT_TO_DEVICE           (-10608)
#define BTPM_ERROR_CODE_PAN_UNABLE_TO_DISCONNECT_DEVICE           (-10609)
#define BTPM_ERROR_CODE_PAN_EVENT_HANDLER_ALREADY_REGISTERED      (-10610)
#define BTPM_ERROR_CODE_PAN_EVENT_HANDLER_NOT_REGISTERED          (-10611)

#define BTPM_ERROR_CODE_MESSAGE_ACCESS_NOT_INITIALIZED               (-10700)
#define BTPM_ERROR_CODE_INVALID_MESSAGE_ACCESS_INITIALIZATION_DATA   (-10701)
#define BTPM_ERROR_CODE_MESSAGE_ACCESS_INVALID_OPERATION             (-10702)
#define BTPM_ERROR_CODE_MESSAGE_ACCESS_CONNECTION_IN_PROGRESS        (-10703)
#define BTPM_ERROR_CODE_MESSAGE_ACCESS_DEVICE_ALREADY_CONNECTED      (-10704)
#define BTPM_ERROR_CODE_MESSAGE_ACCESS_DEVICE_NOT_CONNECTED          (-10705)
#define BTPM_ERROR_CODE_MESSAGE_ACCESS_UNABLE_TO_CONNECT_TO_DEVICE   (-10706)
#define BTPM_ERROR_CODE_MESSAGE_ACCESS_CONNECTION_RETRIES_EXCEEDED   (-10707)
#define BTPM_ERROR_CODE_MESSAGE_ACCESS_UNABLE_TO_DISCONNECT_DEVICE   (-10708)
#define BTPM_ERROR_CODE_MESSAGE_ACCESS_DUPLICATE_INSTANCE_ID         (-10709)
#define BTPM_ERROR_CODE_MESSAGE_ACCESS_INVALID_INSTANCE_ID           (-10710)
#define BTPM_ERROR_CODE_MESSAGE_ACCESS_SERVICE_NOT_ADVERTISED        (-10711)
#define BTPM_ERROR_CODE_MESSAGE_ACCESS_NOTIFICATIONS_NOT_ENABLED     (-10712)
#define BTPM_ERROR_CODE_MESSAGE_ACCESS_ABORT_OPERATION_IN_PROGRESS   (-10713)
#define BTPM_ERROR_CODE_MESSAGE_ACCESS_NO_OPERATION_IN_PROGRESS      (-10714)
#define BTPM_ERROR_CODE_MESSAGE_ACCESS_INVALID_FOLDER_NAME           (-10715)
#define BTPM_ERROR_CODE_MESSAGE_ACCESS_INVALID_MESSAGE_HANDLE        (-10716)
#define BTPM_ERROR_CODE_MESSAGE_ACCESS_INVALID_PATH                  (-10717)
#define BTPM_ERROR_CODE_MESSAGE_ACCESS_INVALID_CLIENT                (-10718)

#define BTPM_ERROR_CODE_GENERIC_ATTRIBUTE_NOT_INITIALIZED            (-10800)
#define BTPM_ERROR_CODE_GENERIC_ATTRIBUTE_NOT_SUPPORTED              (-10801)
#define BTPM_ERROR_CODE_GENERIC_ATTRIBUTE_INVALID_EVENT_CALLBACK_ID  (-10802)
#define BTPM_ERROR_CODE_GENERIC_ATTRIBUTE_INVALID_CONNECTION         (-10803)
#define BTPM_ERROR_CODE_GENERIC_ATTRIBUTE_INVALID_SERVICE_TABLE      (-10804)
#define BTPM_ERROR_CODE_GENERIC_ATTRIBUTE_INVALID_OPERATION          (-10805)
#define BTPM_ERROR_CODE_GENERIC_ATTRIBUTE_INVALID_ATTRIBUTE_HANDLE   (-10806)
#define BTPM_ERROR_CODE_GENERIC_ATTRIBUTE_INSUFFICIENT_HANDLES       (-10807)
#define BTPM_ERROR_CODE_GENERIC_ATTRIBUTE_INVALID_PERSISTENT_UID     (-10808)
#define BTPM_ERROR_CODE_GENERIC_ATTRIBUTE_INVALID_ATTRIBUTE_OFFSET   (-10809)
#define BTPM_ERROR_CODE_GENERIC_ATTRIBUTE_INVALID_SERVICE_STATE      (-10810)

#define BTPM_ERROR_CODE_HEALTH_DEVICE_NOT_INITIALIZED                (-10900)
#define BTPM_ERROR_CODE_INVALID_HEALTH_DEVICE_INITIALIZATION_DATA    (-10901)
#define BTPM_ERROR_CODE_HEALTH_DEVICE_UNABLE_TO_REGISTER_SDP         (-10902)
#define BTPM_ERROR_CODE_HEALTH_DEVICE_UNABLE_TO_CONNECT_TO_DEVICE    (-10903)
#define BTPM_ERROR_CODE_HEALTH_DEVICE_UNABLE_TO_CONNECT_TO_ENDPOINT  (-10904)
#define BTPM_ERROR_CODE_HEALTH_DEVICE_UNABLE_TO_DISCONNECT_DEVICE    (-10905)
#define BTPM_ERROR_CODE_HEALTH_DEVICE_UNABLE_TO_DISCONNECT_ENDPOINT  (-10906)
#define BTPM_ERROR_CODE_HEALTH_DEVICE_UNABLE_TO_REGISTER_ENDPOINT    (-10907)
#define BTPM_ERROR_CODE_HEALTH_DEVICE_INVALID_ENDPOINT_ID            (-10908)
#define BTPM_ERROR_CODE_HEALTH_DEVICE_ENDPOINT_NOT_REGISTERED        (-10909)
#define BTPM_ERROR_CODE_HEALTH_DEVICE_REMOTE_INSTANCE_IN_USE         (-10910)
#define BTPM_ERROR_CODE_HEALTH_DEVICE_CONNECTION_IN_PROGRESS         (-10911)
#define BTPM_ERROR_CODE_HEALTH_DEVICE_NOT_CONNECTED                  (-10912)
#define BTPM_ERROR_CODE_HEALTH_DEVICE_ENDPOINT_NOT_CONNECTED         (-10913)
#define BTPM_ERROR_CODE_HEALTH_DEVICE_SERVICE_NOT_FOUND              (-10914)
#define BTPM_ERROR_CODE_HEALTH_DEVICE_INVALID_DATALINK_ID            (-10915)
#define BTPM_ERROR_CODE_HEALTH_DEVICE_INVALID_CHANNEL_MODE           (-10916)
#define BTPM_ERROR_CODE_HEALTH_DEVICE_INSTANCE_ALREADY_CONNECTED     (-10917)

   /* Since the profiles from here jump all the way to -20000, and we   */
   /* have run out of room for core error codes in the 10000-10099      */
   /* range, we will go ahead and claim the -11000 block for new core   */
   /* error codes.                                                      */
#define BTPM_ERROR_CODE_DEVICE_ROLE_SWITCH_ERROR                     (-11000)

#define BTPM_ERROR_CODE_ALERT_NOTIFICATION_NOT_INITIALIZED           (-20000)
#define BTPM_ERROR_CODE_ALERT_NOTIFICATION_EVENT_ALREADY_REGISTERED  (-20001)
#define BTPM_ERROR_CODE_ALERT_NOTIFICATION_INVALID_CALLBACK_ID       (-20002)
#define BTPM_ERROR_CODE_ALERT_NOTIFICATION_REQUEST_IN_PROGRESS       (-20003)
#define BTPM_ERROR_CODE_ALERT_NOTIFICATION_ALREADY_ENABLED           (-20004)
#define BTPM_ERROR_CODE_ALERT_NOTIFICATION_NOT_ENABLED               (-20005)
#define BTPM_ERROR_CODE_ALERT_NOTIFICATION_NOT_CONNECTED             (-20006)

#define BTPM_ERROR_CODE_HEART_RATE_NOT_INITIALIZED                      (-20100)
#define BTPM_ERROR_CODE_HEART_RATE_CALLBACK_ALREADY_REGISTERED          (-20101)
#define BTPM_ERROR_CODE_HEART_RATE_CALLBACK_NOT_REGISTERED              (-20102)
#define BTPM_ERROR_CODE_HEART_RATE_SENSOR_NOT_AVAILABLE                 (-20103)
#define BTPM_ERROR_CODE_HEART_RATE_BODY_SENSOR_LOCATION_NOT_SUPPORTED   (-20104)
#define BTPM_ERROR_CODE_HEART_RATE_BODY_SENSOR_LOCATION_OUTSTANDING     (-20105)
#define BTPM_ERROR_CODE_HEART_RATE_RESET_ENERGY_EXPENDED_NOT_SUPPORTED  (-20106)
#define BTPM_ERROR_CODE_HEART_RATE_RESET_ENERGY_EXPENDED_OUTSTANDING    (-20107)

#define BTPM_ERROR_CODE_PROXIMITY_NOT_INITIALIZED                    (-20200)
#define BTPM_ERROR_CODE_PROXIMITY_EVENT_ALREADY_REGISTERED           (-20201)
#define BTPM_ERROR_CODE_PROXIMITY_NOT_CONNECTED_TO_DEVICE            (-20202)
#define BTPM_ERROR_CODE_PROXIMITY_TX_POWER_NOT_VALID                 (-20203)

#define BTPM_ERROR_CODE_FIND_ME_NOT_INITIALIZED                      (-20301)

#define BTPM_ERROR_CODE_TIME_NOT_INITIALIZED                         (-20401)
#define BTPM_ERROR_CODE_TIME_SERVER_CALLBACK_ALREADY_REGISTERED      (-20402)
#define BTPM_ERROR_CODE_TIME_UNABLE_TO_READ_TIME                     (-20403)
#define BTPM_ERROR_CODE_TIME_CLIENT_NOT_CONNECTED                    (-20404)
#define BTPM_ERROR_CODE_TIME_NOTIFICATIONS_ALREADY_ENABLED           (-20405)
#define BTPM_ERROR_CODE_TIME_REMOTE_OPERATION_NOT_SUPPORTED          (-20406)
#define BTPM_ERROR_CODE_TIME_UNKNOWN_ERROR                           (-20407)

#define BTPM_ERROR_CODE_PHONE_ALERT_STATUS_NOT_INITIALIZED           (-20501)

#define BTPM_ERROR_CODE_BATTERY_NOT_INITIALIZED                      (-20601)
#define BTPM_ERROR_CODE_BATTERY_CALLBACK_NOT_REGISTERED              (-20602)
#define BTPM_ERROR_CODE_BATTERY_INVALID_INSTANCE                     (-20603)
#define BTPM_ERROR_CODE_BATTERY_NOTIFICATIONS_DISABLED               (-20604)
#define BTPM_ERROR_CODE_BATTERY_NOTIFY_UNSUPPORTED                   (-20605)
#define BTPM_ERROR_CODE_BATTERY_IDENTIFICATION_UNSUPPORTED           (-20606)
#define BTPM_ERROR_CODE_BATTERY_READ_REQUEST                         (-20607)
#define BTPM_ERROR_CODE_BATTERY_SAME_REQUEST_OUTSTANDING             (-20608)
#define BTPM_ERROR_CODE_BATTERY_INVALID_TRANSACTION_ID               (-20609)

#define BTPM_ERROR_CODE_BLOOD_PRESSURE_NOT_INITIALIZED               (-20701)
#define BTPM_ERROR_CODE_BLOOD_PRESSURE_CALLBACK_ALREADY_REGISTERED   (-20702)
#define BTPM_ERROR_CODE_BLOOD_PRESSURE_CALLBACK_NOT_REGISTERED       (-20703)
#define BTPM_ERROR_CODE_BLOOD_PRESSURE_BPM_INDICATIONS_DISABLED      (-20704)
#define BTPM_ERROR_CODE_BLOOD_PRESSURE_ICP_NOTIFICATIONS_DISABLED    (-20705)
#define BTPM_ERROR_CODE_BLOOD_PRESSURE_SAME_REQUEST_OUTSTANDING      (-20706)

#define BTPM_ERROR_CODE_HID_OVER_GATT_NOT_INITIALIZED                (-20801)
#define BTPM_ERROR_CODE_HID_OVER_GATT_FEATURE_NOT_SUPPORTED          (-20802)
#define BTPM_ERROR_CODE_HID_OVER_GATT_REQUEST_NOT_VALID              (-20803)
#define BTPM_ERROR_CODE_HID_OVER_GATT_PROTOCOL_MODE_CURRENT          (-20804)
#define BTPM_ERROR_CODE_HID_OVER_GATT_INVALID_REPORT                 (-20805)
#define BTPM_ERROR_CODE_HID_OVER_GATT_DATA_EVENTS_ALREADY_REGISTERED (-20806)

#define BTPM_ERROR_CODE_HEALTH_THERMOMETER_NOT_INITIALIZED           (-20901)
#define BTPM_ERROR_CODE_HEALTH_THERMOMETER_FEATURE_NOT_SUPPORTED     (-20902)
#define BTPM_ERROR_CODE_HEALTH_THERMOMETER_OPERATION_IN_PROGRESS     (-20903)

#define BTPM_ERROR_CODE_GLUCOSE_NOT_INITIALIZED                      (-21001)
#define BTPM_ERROR_CODE_GLUOCSE_INVALID_PROCEDURE_DATA               (-21002)
#define BTPM_ERROR_CODE_GLUOCSE_PROCEDURE_IN_PROGRESS                (-21003)
#define BTPM_ERROR_CODE_GLUOCSE_STOP_PROCEDURE_IN_PROGRESS           (-21004)

#define BTPM_ERROR_CODE_FTP_NOT_INITIALIZED                          (-22001)
#define BTPM_ERROR_CODE_GOEP_COMMAND_NOT_ALLOWED                     (-22002)
#define BTPM_ERROR_CODE_FTP_ACTION_NOT_ALLOWED                       (-22003)
#define BTPM_ERROR_CODE_FTP_UNABLE_TO_CREATE_LOCAL_FILE              (-22004)
#define BTPM_ERROR_CODE_FTP_INVALID_ROOT_DIRECTORY                   (-22005)
#define BTPM_ERROR_CODE_FTP_REQUEST_OUTSTANDING                      (-22006)
#define BTPM_ERROR_CODE_FTP_ALREADY_CONNECTED                        (-22007)

#define BTPM_ERROR_CODE_HEADSET_NOT_INITIALIZED                      (-23000)
#define BTPM_ERROR_CODE_HEADSET_ROLE_NOT_SUPPORTED                   (-23001)
#define BTPM_ERROR_CODE_HEADSET_INVALID_OPERATION                    (-23002)
#define BTPM_ERROR_CODE_HEADSET_CONNECTION_IN_PROGRESS               (-23003)
#define BTPM_ERROR_CODE_HEADSET_ALREADY_CONNECTED                    (-23004)
#define BTPM_ERROR_CODE_HEADSET_NOT_CONNECTED                        (-23005)
#define BTPM_ERROR_CODE_HEADSET_IS_STILL_CONNECTED                   (-23006)
#define BTPM_ERROR_CODE_HEADSET_UNABLE_TO_CONNECT_TO_DEVICE          (-23007)
#define BTPM_ERROR_CODE_HEADSET_CONNECTION_RETRIES_EXCEEDED          (-23008)
#define BTPM_ERROR_CODE_HEADSET_UNABLE_TO_DISCONNECT_DEVICE          (-23009)
#define BTPM_ERROR_CODE_HEADSET_EVENT_HANDLER_ALREADY_REGISTERED     (-23010)
#define BTPM_ERROR_CODE_HEADSET_EVENT_HANDLER_NOT_REGISTERED         (-23011)
#define BTPM_ERROR_CODE_HEADSET_DATA_HANDLER_ALREADY_REGISTERED      (-23012)
#define BTPM_ERROR_CODE_HEADSET_DATA_HANDLER_NOT_REGISTERED          (-23013)
#define BTPM_ERROR_CODE_INVALID_HEADSET_INITIALIZATION_DATA          (-23014)

#define BTPM_ERROR_CODE_ANT_NOT_INITIALIZED                          (-24000)
#define BTPM_ERROR_CODE_ANT_UNABLE_TO_SEND_ANT_MESSAGE               (-24001)
#define BTPM_ERROR_CODE_ANT_MESSAGE_RESPONSE_ERROR                   (-24002)
#define BTPM_ERROR_CODE_ANT_INVALID_NETWORK_KEY                      (-24003)
#define BTPM_ERROR_CODE_ANT_FEATURE_NOT_AVAILABLE                    (-24004)
#define BTPM_ERROR_CODE_ANT_INVALID_CALLBACK_ID                      (-24005)
#define BTPM_ERROR_CODE_ANT_EVENT_HANDLER_ALREADY_REGISTERED         (-24006)

#define BTPM_ERROR_CODE_ANCS_NOT_INITIALIZED                         (-25000)
#define BTPM_ERROR_CODE_ANCS_CALLBACK_ALREADY_REGISTERED             (-25001)
#define BTPM_ERROR_CODE_ANCS_CALLBACK_NOT_REGISTERED                 (-25002)
#define BTPM_ERROR_CODE_ANCS_INVALID_COMMAND_DATA                    (-25003)
#define BTPM_ERROR_CODE_ANCS_SERVICE_NOT_PRESENT                     (-25004)
#define BTPM_ERROR_CODE_ANCS_REQUEST_CURRENTLY_PENDING               (-25005)
#define BTPM_ERROR_CODE_ANCS_UNABLE_TO_PARSE_DATA                    (-25006)

#define BTPM_ERROR_CODE_OBJECT_PUSH_NOT_INITIALIZED                  (-26700)
#define BTPM_ERROR_CODE_OBJECT_PUSH_INVALID_OPERATION                (-26701)
#define BTPM_ERROR_CODE_OBJECT_PUSH_CONNECTION_IN_PROGRESS           (-26702)
#define BTPM_ERROR_CODE_OBJECT_PUSH_DEVICE_ALREADY_CONNECTED         (-26703)
#define BTPM_ERROR_CODE_OBJECT_PUSH_DEVICE_NOT_CONNECTED             (-26704)
#define BTPM_ERROR_CODE_OBJECT_PUSH_UNABLE_TO_CONNECT_TO_DEVICE      (-26705)
#define BTPM_ERROR_CODE_OBJECT_PUSH_CONNECTION_RETRIES_EXCEEDED      (-26706)
#define BTPM_ERROR_CODE_OBJECT_PUSH_UNABLE_TO_DISCONNECT_DEVICE      (-26707)
#define BTPM_ERROR_CODE_OBJECT_PUSH_SERVICE_NOT_ADVERTISED           (-26708)
#define BTPM_ERROR_CODE_OBJECT_PUSH_ABORT_OPERATION_IN_PROGRESS      (-26709)
#define BTPM_ERROR_CODE_OBJECT_PUSH_NO_OPERATION_IN_PROGRESS         (-26710)
#define BTPM_ERROR_CODE_OBJECT_PUSH_INVALID_CLIENT                   (-26711)
#define BTPM_ERROR_CODE_OBJECT_PUSH_INVALID_SERVER_ID                (-26712)

#define BTPM_ERROR_CODE_HDD_NOT_INITIALIZED                          (-27000)
#define BTPM_ERROR_CODE_HDD_HOST_ALREADY_CONNECTED                   (-27001)
#define BTPM_ERROR_CODE_HDD_CONNECTION_IN_PROGRESS                   (-27002)
#define BTPM_ERROR_CODE_HDD_UNABLE_TO_CONNECT_REMOTE_HOST            (-27003)
#define BTPM_ERROR_CODE_HDD_EVENT_HANDLER_NOT_REGISTERED             (-27004)
#define BTPM_ERROR_CODE_HDD_DATA_EVENTS_ALREADY_REGISTERED           (-27005)
#define BTPM_ERROR_CODE_HDD_DATA_EVENT_HANDLER_NOT_REGISTERED        (-27006)
#define BTPM_ERROR_CODE_HDD_HOST_NOT_CONNECTED                       (-27007)

#define BTPM_ERROR_CODE_CSC_NOT_INITIALIZED                          (-28000)
#define BTPM_ERROR_CODE_CSC_NOT_CONNECTED                            (-28001)
#define BTPM_ERROR_CODE_CSC_ALREADY_CONFIGURED                       (-28002)
#define BTPM_ERROR_CODE_CSC_NOT_CONFIGURED                           (-28003)
#define BTPM_ERROR_CODE_CSC_CONTROL_POINT_PROCEDURE_IN_PROGRESS      (-28004)
#define BTPM_ERROR_CODE_CSC_INVALID_CALLBACK_ID                      (-28005)
#define BTPM_ERROR_CODE_CSC_CURRENTLY_UN_CONFIGURING                 (-28006)
#define BTPM_ERROR_CODE_CSC_CURRENTLY_CONFIGURING                    (-28007)
#define BTPM_ERROR_CODE_CSC_SAME_REQUEST_ALREADY_OUTSTANDING         (-28008)
#define BTPM_ERROR_CODE_CSC_REMOTE_FEATURE_NOT_SUPPORTED             (-28009)

#define BTPM_ERROR_CODE_CYCLING_POWER_NOT_INITIALIZED                (-29000)
#define BTPM_ERROR_CODE_CYCLING_POWER_CALLBACK_NOT_REGISTERED        (-29001)
#define BTPM_ERROR_CODE_CYCLING_POWER_INVALID_INSTANCE               (-29002)
#define BTPM_ERROR_CODE_CYCLING_POWER_INVALID_SENSOR                 (-29003)
#define BTPM_ERROR_CODE_CYCLING_POWER_UPDATE_NOT_REGISTERED          (-29004)
#define BTPM_ERROR_CODE_CYCLING_POWER_TRANSACTION_TIMEOUT            (-29005)
#define BTPM_ERROR_CODE_CYCLING_POWER_UNKNOWN_ERROR                  (-29006)

#define BTPM_ERROR_CODE_RSC_NOT_INITIALIZED                          (-30000)
#define BTPM_ERROR_CODE_RSC_NOT_CONNECTED                            (-30001)
#define BTPM_ERROR_CODE_RSC_ALREADY_CONFIGURED                       (-30002)
#define BTPM_ERROR_CODE_RSC_NOT_CONFIGURED                           (-30003)
#define BTPM_ERROR_CODE_RSC_CONTROL_POINT_PROCEDURE_IN_PROGRESS      (-30004)
#define BTPM_ERROR_CODE_RSC_INVALID_CALLBACK_ID                      (-30005)
#define BTPM_ERROR_CODE_RSC_CURRENTLY_UN_CONFIGURING                 (-30006)
#define BTPM_ERROR_CODE_RSC_CURRENTLY_CONFIGURING                    (-30007)
#define BTPM_ERROR_CODE_RSC_SAME_REQUEST_ALREADY_OUTSTANDING         (-30008)
#define BTPM_ERROR_CODE_RSC_REMOTE_FEATURE_NOT_SUPPORTED             (-30009)

#define BTPM_ERROR_CODE_3D_SYNC_NOT_INITIALIZED                      (-31000)
#define BTPM_ERROR_CODE_3D_SYNC_INVALID_INITIALIZATION_DATA          (-31001)
#define BTPM_ERROR_CODE_3D_SYNC_INVALID_CALLBACK_ID                  (-31002)
#define BTPM_ERROR_CODE_3D_SYNC_CONTROL_ALREADY_REGISTERED           (-31003)
#define BTPM_ERROR_CODE_3D_SYNC_UNKNOWN_ERROR                        (-31004)

   /* The following function is a utility function that exists to       */
   /* retrieve the human readable string value for the specified error  */
   /* code (first parameter).  This function will ALWAYS return a       */
   /* NON-NULL value that is a pointer to a static string.  The memory  */
   /* that this string points to owned by the error handler module and  */
   /* cannot be changed (i.e. the pointer must be treated as pointing   */
   /* to constant data.                                                 */
BTPSAPI_DECLARATION char *BTPSAPI ERR_ConvertErrorCodeToString(int ErrorCode);

#ifdef INCLUDE_BLUETOOTH_API_PROTOTYPES
   typedef char * (BTPSAPI *PFN_ERR_ConvertErrorCodeToString_t)(int ErrorCode);
#endif

#endif
